 {     ᪮ ⥪ SVGA32L }
 { ᫨  㦭 室  楤,      }
 { 䠩 svga32l.pas  }
 { HTTP: www.coolsoftteam.narod.ru   EMAIL: cooler@tut.by  FIDO: 2:450/164.5 }

 {$F+}
 unit svgadrv;
  interface
  const
   on=true;
   off=false;
  type
   modeinfotype=record
    info:word;
    winA,winB:byte;
    step,wsize,segA,segB:word;
    posfun:pointer;
    bperline,hres,vres:word;
    textwidth,textheight,layers,bits,banks,model,banksize,pages:byte;
    videoaddr:longint;
   end;
   palette=array[0..255,0..2] of byte;
   palreg=array[0..3] of byte;
   rgbpalette=array[0..31,0..31,0..31] of byte;
   table=array[0..255] of byte;
   shortstr=string[53];
  var
   modeinfo:^modeinfotype;
   curpal,userpal,savepal:^palette;
   rgbpal:^rgbpalette;
   ctable:^table;
   vseg:word;

   getvbever:function:word;             {।  VBE}
   SetVesaMode:procedure(mode:word);    {⠭ ०}
   setmode:procedure(mode:byte);
   getmode:function:word;
   findmode:function(xres,yres:integer):integer; { ०   ࠧ襭 }
   getmodeinfo:function(mode:word):pointer;  { 㪠⥫   VBE ଠ樨  ०}
   setparams:procedure(hs,ys:integer);    {⠭ ࠬ ०}
   scrollto:procedure(newx,newy:integer); { ஫}
   setvirtual:procedure(hv,yv,stl:integer); {㠫 ࠬ ०}
   createvseg:function:word;     { ᥣ}
   statusline:procedure(fl:boolean); {/몫 饯 }
   getvseg:function:word;        {   }
   setvseg:procedure(s:word);    {⠭ 㡫騩  }
   setcol:procedure(c:byte);     {⠭ 梥}
   getmaxx:function:integer;
   getmaxy:function:integer;
   setfon:procedure(f:byte);     { -//-      䮭}
   clear:procedure;              { ࠭}
   putp:procedure(x,y:word);     {ᮢ }
   hline:procedure(x1,x2,y:integer); {ᮢ ਧ⠫ }
   vline:procedure(x,y1,y2:integer); {ᮢ ⨪ }
   rect:procedure(x1,y1,x2,y2:integer);    {ᮢ אַ㣮쭨}
   xorrect:procedure(x1,y1,x2,y2:integer); {-//-   XOR}
   bar:procedure(x1,y1,x2,y2:integer);     {ᮢ  אַ㣮쭨}
   maskbar:procedure(x1,y1,x2,y2:integer); { אַ㣮쭨 ᪮}
   fillbar:procedure(x1,y1,x2,y2:integer;var tex); { אַ㣮쭨 ⥪ன}
   setrgbreg:procedure(n,r,g,b:byte;fl:boolean); {⠭ ॣ }
   setpalette:procedure(var palette;fl:boolean); {⠭  }
   getpalette:function:pointer;   { }
   setuserpal:procedure(var palette;size:integer); {⠭  }
   calcpal:procedure;
   calcrgbpal:procedure(max:byte);
   adjustBar:procedure(x1,y1,x2,y2:integer); {४   ᬥ }
   usercol:procedure(c:byte);              { 梥, 訩  쭮 }
   rgbcol:procedure(r,g,b:byte);           { 訩 梥  }
   adjust:procedure(var buf;size:longint); {८ࠧ UserPal -> CurPal }

   getmainaddr:procedure(var buf);
   putimage:procedure(x1,y1:integer;var im);        {뢥 bitmap}
   getimage:procedure(x1,y1,x2,y2:integer;var im);  { bitmap  }
   putspr:procedure(x1,y1:integer;var im);    {뢥 ࠩ (bitmap  㫥 ஧ 梥⮬)}
   setclip:procedure(x1,y1,x2,y2:integer);    {⠭  祭}
   loadfont:procedure(name:shortstr;posit:longint); {㧨 }
   registerfont:procedure(p:pointer);        {⠭   }
   setfcol:procedure(c1,c2,c3:byte);         {⠭ 梥  }
   setfont:procedure(n:byte);                { }
   setfontmode:procedure(m:byte);            {ࢠ  ᨬ}
   getfontnum:function(name:shortstr):integer; {   }
   getstrlen:function(st:string):integer;      {।  ப  窠}
   fontH:function:byte;                        { ⥪.  }
   wrtstr:procedure(x,y:integer;st:string);    {뢥 ப ⥪}
   wrtstr2:procedure(x,y:integer;st:string);   {-//- 뢮  梥 1}

   setcursor:procedure(dx,dy:shortint;image:pointer); {⠭ ࠧ }
   showcurs:procedure;      { }
   hidecurs:procedure;      {몫 }
   setcurswin:procedure(x1,y1,x2,y2:integer); {⠭   }
   movecurs:procedure(newx,newy:integer); {६ }
   ofscurs:procedure(dx,dy:integer);      {ᬥ  ⭮⥫쭮 ⥪饣 }
   cursx:function:integer;                { X-न }
   cursy:function:integer;                { Y-न }
   changecurs:procedure(dx,dy:shortint;image:pointer); {  }
   getcursx:function:integer;             {same as cursx}
   getcursy:function:integer;             {same as cursy}

   procedure loaddriver(st:pchar);
   procedure initpal;
  implementation
   uses winapi;
   var
    driver:thandle;
   procedure loaddriver;
    begin
     driver:=loadlibrary(st);
     if driver>=32 then begin
      @GetVBEVer:=getprocaddress(driver,'getvbever');
      @SetVesaMode:=getprocaddress(driver,'setvesamode');
      @setmode:=getprocaddress(driver,'setmode');
      @getmode:=getprocaddress(driver,'getmode');
      @getmodeinfo:=getprocaddress(driver,'getmodeinfo');
      @setparams:=getprocaddress(driver,'setparams');
      @scrollto:=getprocaddress(driver,'scrollto');
      @setvirtual:=getprocaddress(driver,'setvirtual');
      @createvseg:=getprocaddress(driver,'createvseg');
      @getvseg:=getprocaddress(driver,'getvseg');
      @setvseg:=getprocaddress(driver,'setvseg');
      @setcol:=getprocaddress(driver,'setcol');
      @setfon:=getprocaddress(driver,'setfon');
      @clear:=getprocaddress(driver,'clear');
      @putp:=getprocaddress(driver,'putp');
      @hline:=getprocaddress(driver,'hline');
      @vline:=getprocaddress(driver,'vline');
      @rect:=getprocaddress(driver,'rect');
      @xorrect:=getprocaddress(driver,'xorrect');
      @bar:=getprocaddress(driver,'bar');
      @maskbar:=getprocaddress(driver,'maskbar');
      @fillbar:=getprocaddress(driver,'fillbar');
      @setrgbreg:=getprocaddress(driver,'setrgbreg');
      @setpalette:=getprocaddress(driver,'setpalette');
      @getpalette:=getprocaddress(driver,'getpalette');
      @setuserpal:=getprocaddress(driver,'setuserpal');
      @calcpal:=getprocaddress(driver,'calcpal');
      @calcrgbpal:=getprocaddress(driver,'calcrgbpal');
      @adjustbar:=getprocaddress(driver,'adjustbar');
      @usercol:=getprocaddress(driver,'usercol');
      @rgbcol:=getprocaddress(driver,'rgbcol');
      @adjust:=getprocaddress(driver,'adjust');
      @putimage:=getprocaddress(driver,'putimage');
      @getimage:=getprocaddress(driver,'getimage');
      @putspr:=getprocaddress(driver,'putspr');
      @setclip:=getprocaddress(driver,'setclip');
      @loadfont:=getprocaddress(driver,'loadfont');
      @registerfont:=getprocaddress(driver,'registerfont');
      @setfcol:=getprocaddress(driver,'setfcol');
      @fontH:=getprocaddress(driver,'fontH');
      @wrtstr:=getprocaddress(driver,'wrtstr');
      @wrtstr2:=getprocaddress(driver,'wrtstr2');
      @setfont:=getprocaddress(driver,'setfont');
      @setfontmode:=getprocaddress(driver,'setfontmode');
      @getfontnum:=getprocaddress(driver,'getfontnum');
      @getstrlen:=getprocaddress(driver,'getstrlen');
      @setcursor:=getprocaddress(driver,'setcursor');
      @showcurs:=getprocaddress(driver,'showcurs');
      @hidecurs:=getprocaddress(driver,'hidecurs');
      @setcurswin:=getprocaddress(driver,'setcurswin');
      @movecurs:=getprocaddress(driver,'movecurs');
      @ofscurs:=getprocaddress(driver,'ofscurs');
      @cursx:=getprocaddress(driver,'getcursx');
      @cursy:=getprocaddress(driver,'getcursy');
      @changecurs:=getprocaddress(driver,'changecurs');
      @statusline:=getprocaddress(driver,'statusline');
      @getcursx:=getprocaddress(driver,'getcursx');
      @getcursy:=getprocaddress(driver,'getcursy');
      @findmode:=getprocaddress(driver,'findmode');
      @getmaxx:=getprocaddress(driver,'getmaxx');
      @getmaxy:=getprocaddress(driver,'getmaxy');

      @getmainaddr:=getprocaddress(driver,'getmainaddr');
     end else begin
      writeln('Error loading graphics driver : ',st);
      halt;
     end;
    end;
   procedure initpal;
    begin
     getmainaddr(curpal);
    end;
 end.